--------------------------------------------------------------------------------
-- New Check to Display Player behind you
-- Created by Jana Sol for Formula Kart Blast DX
-- Edited by Dinomial for use in Disaster Dash
--------------------------------------------------------------------------------
local CHEK_Y = 182

local new_check = CV_RegisterVar({
	name = "new_check",
	defaultvalue = "On",
	possiblevalue = CV_OnOff
})

local function FKB_K_FindCheckX(px, py, ang, mx, my)
	local dist, x
	local range = RING_DIST/3
	local diff

	range = $*(CV_FindVar("kartspeed").value+1)

	dist = abs(R_PointToDist2(px, py, mx, my))
	if (dist > range) then
		return -3200
	end
	--print("Dist check")
	diff = R_PointToAngle2(px, py, mx, my) - ang

	if (diff < ANGLE_90 and diff > ANGLE_270)
		return -3200
	else
		x = (FixedMul(tan(diff, true), 160<<FRACBITS)+ (160<<FRACBITS))>>FRACBITS
	end
	--print("Diff check")
 	if (CV_FindVar("kartencore").value == 1)
 		x = 320-x
 	end
	return x
end

local function drawNewPlayerCheck(v, p)
	local x
	local xscaleint,xscalefixed = v.dupx()
	local yscaleint,yscalefixed = v.dupy()
	--print(xscaleint, xscalefixed)
	--print(yscaleint, yscalefixed)
	--print(CV_FindVar("kartencore").value)
	local flags = V_SNAPTOBOTTOM
	if p.spectator
	or splitscreen
		return
	end
	
	if not (p.splitscreenindex == 0 and gametype == GT_RACE and new_check.value)
		hud.enable("check")
		return 
	end
	hud.disable("check")
	for p2 in players.iterate do
		if p == p2 then continue end
		if not p2.mo then continue end
		if not p.mo then continue end
		x = FKB_K_FindCheckX(p.mo.x, p.mo.y, p.mo.angle, p2.mo.x, p2.mo.y)
		--print("Value Returned")
		--print(x)
		if (/*x <= 420 and*/ x >= 0) then
			/*if (x < 14)
				x = 14
			elseif (x > 306)
				x = 306
			end*/
			--print("x is good")
			local color = v.getColormap(TC_DEFAULT, p2.mo.color)
			local patch = v.cachePatch(skins[p2.mo.skin].facemmap)
			local scale = FixedDiv(p2.mo.scale, mapobjectscale)
			if p2.kartstuff[k_growshrinktimer] == 0 then
				v.drawScaled((x - 6)*FRACUNIT, CHEK_Y*FRACUNIT, FRACUNIT, patch, V_HUDTRANS|V_SNAPTOBOTTOM, color)
			elseif p2.kartstuff[k_growshrinktimer] > 0 then
				//If using Grow, Make the Player Icon Bigger
				v.drawScaled((x - 12)*FRACUNIT, (CHEK_Y - 6)*FRACUNIT, FRACUNIT*2, patch, V_HUDTRANS|V_SNAPTOBOTTOM, color)
			elseif p2.kartstuff[k_growshrinktimer] < 0 then
				//If using Shrink, Make the Player Icon Smaller
				v.drawScaled((x - 3)*FRACUNIT, (CHEK_Y + 6)*FRACUNIT, FRACUNIT/2, patch, V_HUDTRANS|V_SNAPTOBOTTOM, color)
			end
			local textoffset = v.stringWidth(p2.name, V_HUDTRANS|V_SNAPTOBOTTOM, "thin")/2
			if x > 20000 then 
				textoffset = (x - 65535) - $ 
			else
				textoffset = x - $
			end
			v.drawString(textoffset, CHEK_Y - 12, p2.name, V_HUDTRANS|V_SNAPTOBOTTOM, "thin")
			if (HOSTMOD) and hm_restat == true and p2.HMRs then
				local restatSpatch = v.cachePatch("OPPRNK0"..tostring(p2.HMRs))
				local restatWpatch = v.cachePatch("OPPRNK0"..tostring(p2.HMRw))
				v.draw(x - 10, CHEK_Y - 4, restatSpatch, V_HUDTRANS|V_SNAPTOBOTTOM)
				v.draw(x + 3, CHEK_Y + 8, restatWpatch, V_HUDTRANS|V_SNAPTOBOTTOM)
			end
			--v.draw(x, CHEK_Y, patch, V_HUDTRANS|V_SNAPTOBOTTOM, color)
		end
	end
end

hud.add(drawNewPlayerCheck, "game")